/*
 * Copyright (C) 2017 PayKeeper
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * @author      PayKeeper
 * @copyright   2017 PayKeeper
 * @license     http://opensource.org/licenses/gpl-2.0.php GNU General Public License, version 2 (GPL-2.0)
 */

define(
    [
        'jquery',
        'Magento_Checkout/js/model/quote',
        'Magento_Checkout/js/model/url-builder',
        'mage/storage',
        'Magento_Customer/js/customer-data',
        'Magento_Checkout/js/view/payment/default',
        'Magento_Checkout/js/action/place-order',
        'Magento_Checkout/js/action/select-payment-method',
        'Magento_Customer/js/model/customer',
        'Magento_Checkout/js/checkout-data',
        'Magento_Checkout/js/model/payment/additional-validators',
        'mage/url',
    ],
    function (
        $,
        quote,
        urlBuilder,
        storage,
        customerData,
        Component,
        placeOrderAction,
        selectPaymentMethodAction,
        customer,
        checkoutData,
        additionalValidators,
        url
    ) {
        'use strict';

        return Component.extend({
            defaults: {
                template: 'PayKeeper_PayKeeper/payment/method/checkout/form'
            },

//            placeOrder: function (data, event) {
//
//                if (event) {
//                    event.preventDefault();
//                }
//                var self = this;
//                self.placeOrder();
//                window.location.replace(url.build('paykeeper/checkout/payment'));
//                var self = this,
//                    placeOrder,
//                    emailValidationResult = customer.isLoggedIn(),
//                    loginFormSelector = 'form[data-role=email-with-possible-login]';
//                if (!customer.isLoggedIn()) {
//                    $(loginFormSelector).validation();
//                    emailValidationResult = Boolean($(loginFormSelector + ' input[name=username]').valid());
//                }
//                if (emailValidationResult && this.validate() && additionalValidators.validate()) {
//                    this.isPlaceOrderActionAllowed(false);
//                    placeOrder = placeOrderAction(this.getData(), false, this.messageContainer);
//
//                    $.when(placeOrder).fail(function () {
//                        self.isPlaceOrderActionAllowed(true);
//                    }).done(window.location.replace(url.build('paykeeper/checkout/payment')));
//                    //window.location.replace(url.build('paykeeper/checkout/payment'));
//                    //return true;
//                }
//                return false;
//            },

//            selectPaymentMethod: function () {
//                selectPaymentMethodAction(this.getData());
//                checkoutData.setSelectedPaymentMethod(this.item.method);
//                return true;
//            },
            /**
             * Place order.
             */
            placeOrder: function (data, event) {
                var self = this;

                if (event) {
                    event.preventDefault();
                }   

                if (this.validate() && additionalValidators.validate()) {
                    this.isPlaceOrderActionAllowed(false);

                    this.getPlaceOrderDeferredObject()
                        .fail(
                            function () {
                                self.isPlaceOrderActionAllowed(true);
                            }   
                        ).done(
                            function () {
                                self.afterPlaceOrder();

//                                if (self.redirectAfterPlaceOrder) {
//                                    redirectOnSuccessAction.execute();
//                                }   
                            }   
                        );  

                    return true;
                }   

                return false;
            },

            afterPlaceOrder: function () {
                window.location.replace(url.build('paykeeper/checkout/payment'));
            }

        });
    }
);
